Package org.flywaydb.core.api.configuration

## Interface Configuration

- All Known Implementing Classes:
    `ClassicConfiguration`, `FluentConfiguration`

      public interface Configuration

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getBaselineDescription()` | Retrieves the description to tag an existing schema with when executing baseline.
    `MigrationVersion` | `getBaselineVersion()` | Retrieves the version to tag an existing schema with when executing baseline.
    `Callback[]` | `getCallbacks()` | Gets the callbacks for lifecycle notifications.
    `MigrationPattern[]` | `getCherryPick()` | Gets the migrations that Flyway should consider when migrating or undoing.
    `java.lang.ClassLoader` | `getClassLoader()` | Retrieves the ClassLoader to use for loading migrations, resolvers, etc.
    `int` | `getConnectRetries()` | The maximum number of retries when attempting to connect to the database.
    `int` | `getConnectRetriesInterval()` | The maximum time between retries when attempting to connect to the database in seconds.
    `javax.sql.DataSource` | `getDataSource()` | Retrieves the dataSource to use to access the database.
    `java.lang.String` | `getDefaultSchema()` | The default schema managed by Flyway.
    `java.io.OutputStream` | `getDryRunOutput()` | The stream where to output the SQL statements of a migration dry run.
    `java.nio.charset.Charset` | `getEncoding()` | Retrieves the encoding of Sql migrations.
    `java.lang.String[]` | `getErrorOverrides()` | Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.
    `ValidatePattern[]` | `getIgnoreMigrationPatterns()` | Ignore migrations that match this comma-separated list of patterns when validating migrations.
    `java.lang.String` | `getInitSql()` | The SQL statements to run to initialize a new database connection immediately after opening it.
    `java.lang.String` | `getInstalledBy()` | The username that will be recorded in the schema history table as having applied the migration.
    `ClassProvider<JavaMigration>` | `getJavaMigrationClassProvider()` | Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes.
    `JavaMigration[]` | `getJavaMigrations()` | The manually added Java-based migrations.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getJdbcProperties()` | Properties to pass to the JDBC driver object Flyway Teams only
    `java.lang.String` | `getKerberosConfigFile()` | The path to the Kerberos config file.
    `java.lang.String` | `getLicenseKey()` | Your Flyway license key (FL01...).
    `Location[]` | `getLocations()` | Retrieves the locations to scan recursively for migrations.
    `int` | `getLockRetryCount()` | The maximum number of retries when trying to obtain a lock.
    `java.lang.String[]` | `getLoggers()` | The loggers Flyway should use.
    `org.flywaydb.core.internal.configuration.models.ConfigurationModel` | `getModernConfig()` |
    `java.lang.String` | `getOracleKerberosCacheFile()` |
    `java.lang.String` | `getOracleWalletLocation()` | The location of your Oracle wallet, used to automatically sign in to your databases.
    `java.lang.String` | `getPassword()` | Retrieves the password used to construct the dataSource.
    `java.lang.String` | `getPlaceholderPrefix()` | Retrieves the prefix of every placeholder.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getPlaceholders()` | Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
    `java.lang.String` | `getPlaceholderSeparator()` | Retrieves the separator of default placeholders.
    `java.lang.String` | `getPlaceholderSuffix()` | Retrieves the suffix of every placeholder.
    `org.flywaydb.core.internal.plugin.PluginRegister` | `getPluginRegister()` |
    `java.lang.String` | `getRepeatableSqlMigrationPrefix()` | Retrieves the file name prefix for repeatable SQL migrations.
    `MigrationResolver[]` | `getResolvers()` | Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `ResourceProvider` | `getResourceProvider()` | Retrieves the custom ResourceProvider to be used to look up resources.
    `java.lang.String[]` | `getSchemas()` | The schemas managed by Flyway.
    `java.lang.String` | `getScriptPlaceholderPrefix()` | Retrieves the prefix of every script placeholder.
    `java.lang.String` | `getScriptPlaceholderSuffix()` | Retrieves the suffix of every script placeholder.
    `java.lang.String` | `getSqlMigrationPrefix()` | The file name prefix for versioned SQL migrations.
    `java.lang.String` | `getSqlMigrationSeparator()` | Retrieves the file name separator for sql migrations.
    `java.lang.String[]` | `getSqlMigrationSuffixes()` | The file name suffixes for SQL migrations.
    `java.lang.String` | `getTable()` | Retrieves the name of the schema history table that will be used by Flyway.
    `java.lang.String` | `getTablespace()` | The tablespace where to create the schema history table that will be used by Flyway.
    `MigrationVersion` | `getTarget()` | Gets the target version up to which Flyway should consider migrations.
    `java.lang.String` | `getUndoSqlMigrationPrefix()` | The file name prefix for undo SQL migrations.
    `java.lang.String` | `getUrl()` | Retrieves the url used to construct the dataSource.
    `java.lang.String` | `getUser()` | Retrieves the user used to construct the dataSource.
    `boolean` | `isBaselineOnMigrate()` | Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table.
    `boolean` | `isBatch()` | Whether to batch SQL statements when executing them.
    `boolean` | `isCleanDisabled()` | Whether to disable clean.
    `boolean` | `isCleanOnValidationError()` | Whether to automatically call clean or not when a validation error occurs.
    `boolean` | `isCreateSchemas()` | Whether Flyway should attempt to create the schemas specified in the schemas property.
    `boolean` | `isDetectEncoding()` | Whether Flyway should try to automatically detect SQL migration file encoding
    `boolean` | `isExecuteInTransaction()` | Checks whether SQL is executed in a transaction.
    `boolean` | `isFailOnMissingLocations()` | Whether to fail if a location specified in the flyway.locations option doesn't exist
    `boolean` | `isFailOnMissingTarget()` | Whether to fail if no migration with the configured target version exists (default: `true`)
    `boolean` | `isGroup()` | Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
    `boolean` | `isMixed()` | Whether to allow mixing transactional and non-transactional statements within the same migration.
    `boolean` | `isOracleSqlplus()` | Whether to Flyway's support for Oracle SQL*Plus commands should be activated.
    `boolean` | `isOracleSqlplusWarn()` | Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support.
    `boolean` | `isOutOfOrder()` | Allows migrations to be run "out of order".
    `boolean` | `isOutputQueryResults()` | Whether Flyway should output a table with the results of queries when executing migrations.
    `boolean` | `isPlaceholderReplacement()` | Checks whether placeholders should be replaced.
    `boolean` | `isSkipDefaultCallbacks()` | Whether Flyway should skip the default callbacks.
    `boolean` | `isSkipDefaultResolvers()` | Whether Flyway should skip the default resolvers.
    `boolean` | `isSkipExecutingMigrations()` | Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table.
    `boolean` | `isStream()` | Whether to stream SQL migrations when executing them.
    `boolean` | `isValidateMigrationNaming()` | Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention.
    `boolean` | `isValidateOnMigrate()` | Whether to automatically call validate or not when running migrate.

- - ### Method Detail

    - #### getModernConfig

          org.flywaydb.core.internal.configuration.models.ConfigurationModel getModernConfig()

    - #### getClassLoader

          java.lang.ClassLoader getClassLoader()

      Retrieves the ClassLoader to use for loading migrations, resolvers, etc. from the classpath.
      Returns:
        The ClassLoader to use for loading migrations, resolvers, etc. from the classpath. (default: Thread.currentThread().getContextClassLoader() )

    - #### getPluginRegister

          org.flywaydb.core.internal.plugin.PluginRegister getPluginRegister()

    - #### getUrl

          java.lang.String getUrl()

      Retrieves the url used to construct the dataSource. May be null if the dataSource was passed in directly.
      Returns:
        The url used to construct the dataSource. May be null if the dataSource was passed in directly.

    - #### getUser

          java.lang.String getUser()

      Retrieves the user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.
      Returns:
        The user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.

    - #### getPassword

          java.lang.String getPassword()

      Retrieves the password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.
      Returns:
        The password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.

    - #### getDataSource

          javax.sql.DataSource getDataSource()

      Retrieves the dataSource to use to access the database. Must have the necessary privileges to execute DDL.
      Returns:
        The dataSource to use to access the database. Must have the necessary privileges to execute DDL.

    - #### getConnectRetries

          int getConnectRetries()

      The maximum number of retries when attempting to connect to the database. After each failed attempt, Flyway will wait 1 second before attempting to connect again, up to the maximum number of times specified by connectRetries. The interval between retries doubles with each subsequent attempt.
      Returns:
        The maximum number of retries when attempting to connect to the database. (default: 0)

    - #### getConnectRetriesInterval

          int getConnectRetriesInterval()

      The maximum time between retries when attempting to connect to the database in seconds. This will cap the interval between connect retry to the value provided.
      Returns:
        The maximum time between retries in seconds (default: 120)

    - #### getInitSql

          java.lang.String getInitSql()

      The SQL statements to run to initialize a new database connection immediately after opening it.
      Returns:
        The SQL statements. (default: `null`)

    - #### getBaselineVersion

          MigrationVersion getBaselineVersion()

      Retrieves the version to tag an existing schema with when executing baseline.
      Returns:
        The version to tag an existing schema with when executing baseline. (default: 1)

    - #### getBaselineDescription

          java.lang.String getBaselineDescription()

      Retrieves the description to tag an existing schema with when executing baseline.
      Returns:
        The description to tag an existing schema with when executing baseline. (default: << Flyway Baseline >>)

    - #### getResolvers

          MigrationResolver[] getResolvers()

      Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Returns:
        The custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. An empty array if none. (default: none)

    - #### isSkipDefaultResolvers

          boolean isSkipDefaultResolvers()

      Whether Flyway should skip the default resolvers. If true, only custom resolvers are used.
      Returns:
        Whether default built-in resolvers should be skipped. (default: false)

    - #### getCallbacks

          Callback[] getCallbacks()

      Gets the callbacks for lifecycle notifications.
      Returns:
        The callbacks for lifecycle notifications. An empty array if none. (default: none)

    - #### isSkipDefaultCallbacks

          boolean isSkipDefaultCallbacks()

      Whether Flyway should skip the default callbacks. If true, only custom callbacks are used.
      Returns:
        Whether default built-in callbacks should be skipped. (default: false)

    - #### getSqlMigrationPrefix

          java.lang.String getSqlMigrationPrefix()

      The file name prefix for versioned SQL migrations. Versioned SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1.1__My_description.sql
      Returns:
        The file name prefix for sql migrations. (default: V)

    - #### getUndoSqlMigrationPrefix

          java.lang.String getUndoSqlMigrationPrefix()

      The file name prefix for undo SQL migrations. Undo SQL migrations are responsible for undoing the effects of the versioned migration with the same version. They have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to U1.1__My_description.sql Flyway Teams only
      Returns:
        The file name prefix for undo sql migrations. (default: U)

    - #### isExecuteInTransaction

          boolean isExecuteInTransaction()

      Checks whether SQL is executed in a transaction.
      Returns:
        Whether SQL is executed in a transaction. (default: true)

    - #### getRepeatableSqlMigrationPrefix

          java.lang.String getRepeatableSqlMigrationPrefix()

      Retrieves the file name prefix for repeatable SQL migrations. Repeatable SQL migrations have the following file name structure: prefixSeparatorDESCRIPTIONsuffix, which using the defaults translates to R__My_description.sql<
      Returns:
        The file name prefix for repeatable sql migrations. (default: R)

    - #### getSqlMigrationSeparator

          java.lang.String getSqlMigrationSeparator()

      Retrieves the file name separator for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Returns:
        The file name separator for sql migrations. (default: __)

    - #### getSqlMigrationSuffixes

          java.lang.String[] getSqlMigrationSuffixes()

      The file name suffixes for SQL migrations. (default: .sql) SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql Multiple suffixes (like .sql,.pkg,.pkb) can be specified for easier compatibility with other tools such as editors with specific file associations.
      Returns:
        The file name suffixes for SQL migrations.

    - #### getJavaMigrations

          JavaMigration[] getJavaMigrations()

      The manually added Java-based migrations. These are not Java-based migrations discovered through classpath scanning and instantiated by Flyway. Instead these are manually added instances of JavaMigration. This is particularly useful when working with a dependency injection container, where you may want the DI container to instantiate the class and wire up its dependencies for you.
      Returns:
        The manually added Java-based migrations. An empty array if none. (default: none)

    - #### isPlaceholderReplacement

          boolean isPlaceholderReplacement()

      Checks whether placeholders should be replaced.
      Returns:
        Whether placeholders should be replaced. (default: true)

    - #### getPlaceholderSuffix

          java.lang.String getPlaceholderSuffix()

      Retrieves the suffix of every placeholder.
      Returns:
        The suffix of every placeholder. (default: } )

    - #### getPlaceholderPrefix

          java.lang.String getPlaceholderPrefix()

      Retrieves the prefix of every placeholder.
      Returns:
        The prefix of every placeholder. (default: ${ )

    - #### getPlaceholderSeparator

          java.lang.String getPlaceholderSeparator()

      Retrieves the separator of default placeholders.
      Returns:
        The separator of default placeholders. (default: : )

    - #### getScriptPlaceholderSuffix

          java.lang.String getScriptPlaceholderSuffix()

      Retrieves the suffix of every script placeholder.
      Returns:
        The suffix of every script placeholder. (default: __ )

    - #### getScriptPlaceholderPrefix

          java.lang.String getScriptPlaceholderPrefix()

      Retrieves the prefix of every script placeholder.
      Returns:
        The prefix of every script placeholder. (default: FP__ )

    - #### getPlaceholders

          java.util.Map<java.lang.String,​java.lang.String> getPlaceholders()

      Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
      Returns:
        The map of <placeholder, replacementValue> to apply to sql migration scripts.

    - #### getTarget

          MigrationVersion getTarget()

      Gets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - `next`: The next version of the schema, as defined by the first pending migration
      - <version>? (end with a '?'): Instructs Flyway not to fail if the target version doesn't exist. In this case, Flyway will go up to but not beyond the specified target (default: fail if the target version doesn't exist) Flyway Teams only
      Returns:
        The target version up to which Flyway should consider migrations. Defaults to `latest`

    - #### isFailOnMissingTarget

          boolean isFailOnMissingTarget()

      Whether to fail if no migration with the configured target version exists (default: `true`)

    - #### getCherryPick

          MigrationPattern[] getCherryPick()

      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Flyway Teams only
      Returns:
        The migrations that Flyway should consider when migrating or undoing.

    - #### getTable

          java.lang.String getTable()

      Retrieves the name of the schema history table that will be used by Flyway. By default, (single-schema mode) the schema history table is placed in the default schema for the connection provided by the datasource. When the flyway.schemas property is set (multi-schema mode), the schema history table is placed in the first schema of the list, or in the schema specified to flyway.defaultSchema.
      Returns:
        The name of the schema history table that will be used by Flyway. (default: flyway_schema_history)

    - #### getTablespace

          java.lang.String getTablespace()

      The tablespace where to create the schema history table that will be used by Flyway. If not specified, Flyway uses the default tablespace for the database connection. This setting is only relevant for databases that do support the notion of tablespace. Its value is simply ignored for all others.
      Returns:
        The tablespace where to create the schema history table that will be used by Flyway.

    - #### getDefaultSchema

          java.lang.String getDefaultSchema()

      The default schema managed by Flyway. This schema name is case-sensitive. If not specified, but schemas is, Flyway uses the first schema in that list. If that is also not specified, Flyway uses the default schema for the database connection.

      Consequences:

      - This schema will be the one containing the schema history table.
      - This schema will be the default for the database connection (provided the database supports this concept).
      Returns:
        The default schema managed by Flyway, which is where the schema history table will reside. (default: The first schema specified in getSchemas(), and failing that the default schema for the database connection)

    - #### getSchemas

          java.lang.String[] getSchemas()

      The schemas managed by Flyway. These schema names are case-sensitive. If not specified, Flyway uses the default schema for the database connection. If defaultSchema is not specified, then the first of this list also acts as the default schema.

      Consequences:

      - Flyway will automatically attempt to create all these schemas, unless they already exist.
      - The schemas will be cleaned in the order of this list.
      - If Flyway created them, the schemas themselves will be dropped when cleaning.
      Returns:
        The schemas managed by Flyway. (default: The default schema for the database connection)

    - #### getEncoding

          java.nio.charset.Charset getEncoding()

      Retrieves the encoding of Sql migrations.
      Returns:
        The encoding of Sql migrations. (default: UTF-8)

    - #### isDetectEncoding

          boolean isDetectEncoding()

      Whether Flyway should try to automatically detect SQL migration file encoding
      Returns:
        `true` to enable auto detection, `false` otherwise Flyway Teams only

    - #### getLocations

          Location[] getLocations()

      Retrieves the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Returns:
        Locations to scan recursively for migrations. (default: classpath:db/migration)

    - #### isBaselineOnMigrate

          boolean isBaselineOnMigrate()

      Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table. This schema will then be initialized with the `baselineVersion` before executing the migrations. Only migrations above `baselineVersion` will then be applied. This is useful for initial Flyway production deployments on projects with an existing DB. Be careful when enabling this as it removes the safety net that ensures Flyway does not migrate the wrong database in case of a configuration mistake!
      Returns:
        `true` if baseline should be called on migrate for non-empty schemas, `false` if not. (default: `false`)

    - #### isSkipExecutingMigrations

          boolean isSkipExecutingMigrations()

      Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table. This should be used when you have applied a migration manually (via executing the sql yourself, or via an ide), and just want the schema history table to reflect this. Use in conjunction with `cherryPick` to skip specific migrations instead of all pending ones. Flyway Teams only
      Returns:
        `true` if executing the migrations should be skipped on migrate, `false` if not. (default: `false`)

    - #### isOutOfOrder

          boolean isOutOfOrder()

      Allows migrations to be run "out of order". If you already have versions 1 and 3 applied, and now a version 2 is found, it will be applied too instead of being ignored.
      Returns:
        `true` if outOfOrder migrations should be applied, `false` if not. (default: `false`)

    - #### getIgnoreMigrationPatterns

          ValidatePattern[] getIgnoreMigrationPatterns()

      Ignore migrations that match this comma-separated list of patterns when validating migrations. Each pattern is of the form : See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Example: repeatable:missing,versioned:pending,*:failed (default: *:future) Flyway Teams only

    - #### isValidateMigrationNaming

          boolean isValidateMigrationNaming()

      Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention. A failure can be useful to check that errors such as case sensitivity in migration prefixes have been corrected.
      Returns:
        `false` to continue normally, `true` to fail fast with an exception. (default: `false`)

    - #### isValidateOnMigrate

          boolean isValidateOnMigrate()

      Whether to automatically call validate or not when running migrate.
      Returns:
        `true` if validate should be called. `false` if not. (default: `true`)

    - #### isCleanOnValidationError

          boolean isCleanOnValidationError()

      Whether to automatically call clean or not when a validation error occurs. This is exclusively intended as a convenience for development. even though we strongly recommend not to change migration scripts once they have been checked into SCM and run, this provides a way of dealing with this case in a smooth manner. The database will be wiped clean automatically, ensuring that the next migration will bring you back to the state checked into SCM. Warning! Do not enable in production!
      Returns:
        `true` if clean should be called. `false` if not. (default: `false`)

    - #### isCleanDisabled

          boolean isCleanDisabled()

      Whether to disable clean. This is especially useful for production environments where running clean can be a career limiting move.
      Returns:
        `true` to disable clean. `false` to be able to clean. (default: `true`)

    - #### isMixed

          boolean isMixed()

      Whether to allow mixing transactional and non-transactional statements within the same migration. Enabling this automatically causes the entire affected migration to be run without a transaction. Note that this is only applicable for PostgreSQL, Aurora PostgreSQL, SQL Server and SQLite which all have statements that do not run at all within a transaction. This is not to be confused with implicit transaction, as they occur in MySQL or Oracle, where even though a DDL statement was run within a transaction, the database will issue an implicit commit before and after its execution.
      Returns:
        `true` if mixed migrations should be allowed. `false` if an error should be thrown instead. (default: `false`)

    - #### isGroup

          boolean isGroup()

      Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
      Returns:
        `true` if migrations should be grouped. `false` if they should be applied individually instead. (default: `false`)

    - #### getInstalledBy

          java.lang.String getInstalledBy()

      The username that will be recorded in the schema history table as having applied the migration.
      Returns:
        The username or `null` for the current database user of the connection. (default: `null`).

    - #### getErrorOverrides

          java.lang.String[] getErrorOverrides()

      Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.

      Each error override has the following format: `STATE:12345:W`. It is a 5 character SQL state (or * to match all SQL states), a colon, the SQL error code (or * to match all SQL error codes), a colon and finally the desired behavior that should override the initial one.

      The following behaviors are accepted:

      - `D` to force a debug message
      - `D-` to force a debug message, but do not show the original sql state and error code
      - `I` to force an info message
      - `I-` to force an info message, but do not show the original sql state and error code
      - `W` to force a warning
      - `W-` to force a warning, but do not show the original sql state and error code
      - `E` to force an error
      - `E-` to force an error, but do not show the original sql state and error code

      Example 1: to force Oracle stored procedure compilation issues to produce errors instead of warnings, the following errorOverride can be used: `99999:17110:E`

      Example 2: to force SQL Server PRINT messages to be displayed as info messages (without SQL state and error code details) instead of warnings, the following errorOverride can be used: `S0001:0:I-`

      Example 3: to force all errors with SQL error code 123 to be treated as warnings instead, the following errorOverride can be used: `*:123:W`

      Flyway Teams only
      Returns:
        The ErrorOverrides or an empty array if none are defined. (default: none)

    - #### getDryRunOutput

          java.io.OutputStream getDryRunOutput()

      The stream where to output the SQL statements of a migration dry run. `null` if the SQL statements are executed against the database directly. Flyway Teams only
      Returns:
        The stream or `null` if the SQL statements are executed against the database directly.

    - #### isStream

          boolean isStream()

      Whether to stream SQL migrations when executing them. Streaming doesn't load the entire migration in memory at once. Instead each statement is loaded individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this dramatically reduces Flyway's memory consumption. Flyway Teams only
      Returns:
        `true` to stream SQL migrations. `false` to fully loaded them in memory instead. (default: `false`)

    - #### isBatch

          boolean isBatch()

      Whether to batch SQL statements when executing them. Batching can save up to 99 percent of network roundtrips by sending up to 100 statements at once over the network to the database, instead of sending each statement individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this can dramatically reduce the network overhead. This is supported for INSERT, UPDATE, DELETE, MERGE and UPSERT statements. All other statements are automatically executed without batching. Flyway Teams only
      Returns:
        `true` to batch SQL statements. `false` to execute them individually instead. (default: `false`)

    - #### isOracleSqlplus

          boolean isOracleSqlplus()

      Whether to Flyway's support for Oracle SQL*Plus commands should be activated. Flyway Teams only
      Returns:
        `true` to active SQL*Plus support. `false` to fail fast instead. (default: `false`)

    - #### isOracleSqlplusWarn

          boolean isOracleSqlplusWarn()

      Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support. Flyway Teams only
      Returns:
        `true` to issue a warning. `false` to fail fast instead. (default: `false`)

    - #### getKerberosConfigFile

          java.lang.String getKerberosConfigFile()

      The path to the Kerberos config file. Flyway Teams only

    - #### getOracleKerberosCacheFile

          java.lang.String getOracleKerberosCacheFile()

    - #### getLicenseKey

          java.lang.String getLicenseKey()

      Your Flyway license key (FL01...). Not yet a Flyway Teams Edition customer? Request your Flyway trial license key to try out Flyway Teams Edition features free for 30 days. Flyway Teams only
      Returns:
        Your Flyway license key.

    - #### isOutputQueryResults

          boolean isOutputQueryResults()

      Whether Flyway should output a table with the results of queries when executing migrations. Flyway Teams only
      Returns:
        `true` to output the results table (default: `true`)

    - #### getResourceProvider

          ResourceProvider getResourceProvider()

      Retrieves the custom ResourceProvider to be used to look up resources. If not set, the default strategy will be used.
      Returns:
        The custom ResourceProvider to be used to look up resources (default: null)

    - #### getJavaMigrationClassProvider

          ClassProvider<JavaMigration> getJavaMigrationClassProvider()

      Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes. If not set, the default strategy will be used.
      Returns:
        The custom ClassProvider to be used to look up `JavaMigration` classes (default: null)

    - #### isCreateSchemas

          boolean isCreateSchemas()

      Whether Flyway should attempt to create the schemas specified in the schemas property.
      Returns:

    - #### getLockRetryCount

          int getLockRetryCount()

      The maximum number of retries when trying to obtain a lock. -1 indicates attempting to repeat indefinitely.

    - #### getJdbcProperties

          java.util.Map<java.lang.String,​java.lang.String> getJdbcProperties()

      Properties to pass to the JDBC driver object Flyway Teams only
      Returns:
        Properties that will be passed to the JDBC driver object

    - #### isFailOnMissingLocations

          boolean isFailOnMissingLocations()

      Whether to fail if a location specified in the flyway.locations option doesn't exist
      Returns:

    - #### getOracleWalletLocation

          java.lang.String getOracleWalletLocation()

      The location of your Oracle wallet, used to automatically sign in to your databases. Flyway Teams only

    - #### getLoggers

          java.lang.String[] getLoggers()

      The loggers Flyway should use. Valid options are:
      - auto: Auto detect the logger (default behavior)
      - console: Use stdout/stderr (only available when using the CLI)
      - slf4j2: Use the slf4j2 logger
      - log4j2: Use the log4j2 logger
      - apache-commons: Use the Apache Commons logger
      Alternatively you can provide the fully qualified class name for any other logger to use that.